/***************************************************************************
 *            BaseTab.h
 *
 *  Sat Feb 17 20:47:35 2007
 *  Copyright  2007  Fernando Tarín Morales
 *  icemanf@gmail.com
 ****************************************************************************/

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
 
#ifndef _BASETAB_H
#define _BASETAB_H

#include <gtkmm.h>

class BaseTab{
	protected:
		Gtk::Label tabLabel;
		Gtk::Button tabButton;
		Gtk::Image tabImageButton;
		Gtk::HBox tabWidget;
	
		bool shownTab;
	
	public:
		BaseTab();
		BaseTab(const BaseTab &);
		BaseTab(Glib::ustring);
				
		~BaseTab();
			
		bool isTabShown(void) { return shownTab; };
	
		void setShownTab(bool set_shown_tab) { shownTab = set_shown_tab; };
		void setLabel(Glib::ustring & Label) { tabLabel.set_label(Label); };
		Glib::ustring getLabelText(void) { return tabLabel.get_text(); }
			
		// Tab Fields
		Gtk::HBox * getTabWidget(void) { return & tabWidget; };
		Gtk::Button * getTabButton(void) { return & tabButton; };
	
		// Opertator =
		BaseTab& operator=(const BaseTab&);
};

#endif /* _BASETAB_H */

 
