/***************************************************************************
 *            EditTrackersDialog.h
 *
 *  Tue Aug 12 22:51:57 2008
 *  Copyright  2008  Fernando Tarín Morales
 *  <icemanf@gmail.com>
 ****************************************************************************/

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
 
#ifndef EDITTRACKERSDIALOG_H
#define EDITTRACKERSDIALOG_H

#include <Lince/Torrent.h>

#include <gtkmm/dialog.h>
#include <gtkmm/treeview.h>
#include <gtkmm/liststore.h>

#include <glibmm/refptr.h>

#include "Utils.h"

class EditTrackersDialog : public Gtk::Dialog
{
	private:
		bool has_been_modified;
		Lince::Torrent *t;
	
		Utils::ModelColumnsIntString m_Columns;		
		Gtk::TreeView m_TreeView;
		Glib::RefPtr<Gtk::ListStore> m_refTreeModel;
		
		void addTrackers();
		void addTracker();
		void removeTracker();
		void exit();
		
	public:
		EditTrackersDialog(Lince::Torrent *);
		~EditTrackersDialog();
};

#endif /* EDITTRACKERSDIALOG_H */
