/***************************************************************************
 *            MakeTorrent.h
 *
 *  Tue Nov 13 18:27:03 2007
 *  Copyright  2007  Fernando Tarín Morales
 *  icemanf@gmail.com
 ****************************************************************************/

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
 
#ifndef _MAKETORRENT_H
#define _MAKETORRENT_H

#include <gtkmm.h>

class MakeTorrent : public Gtk::Dialog{
	private:
		Gtk::Label torrentWindowLabel;
	
		Gtk::VBox filesVBox;
		Gtk::ScrolledWindow scrolledWindow;
		Gtk::Frame filesFrame;
		Glib::RefPtr<Gtk::TextBuffer::TagTable> refTagTable;
		Glib::RefPtr<Gtk::TextBuffer> TextBuffer;
		Gtk::TextView filesTextView;
		Gtk::HBox filesHBox;
		Gtk::Button fileButton, directoryButton;
	
		Gtk::Label announceLabel;
		Gtk::Entry announceEntry;
			
		Gtk::Label commentLabel;
		Gtk::Entry commentEntry;
			
		Gtk::CheckButton privateTorrentButton;
		
		Gtk::Button *okButton, *cancelButton;
	
		int offset;
		double progress, pulse;
		boost::filesystem::path path;
	
		Gtk::ProgressBar progressBar;
	
		// Thread
		Glib::Dispatcher finishTorrentFinishSignal, updateProgressBarSignal;
		void makeTorrent(Glib::ustring);
	
		void hideWindow();
		void addFile();
		void addDirectory();
		void prepareToMakeTorrent();
		void updateProgressBar();
		void launchUpdateProgressBar(int);
		
		void addFiles(boost::filesystem::path const&, boost::filesystem::path const&);
	
		int getPieceSize();
	
	public:
		MakeTorrent();
		~MakeTorrent();
};

#endif /* _MAKETORRENT_H */

 
