/***************************************************************************
 *            Notifications.h
 *
 *  Copyright  2009  Fernando Tarín Morales
 *  icemanf@gmail.com
 ****************************************************************************/

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */

#ifndef _NOTIFICATIONS_H
#define _NOTIFICATIONS_H

#include <queue>

#include <glibmm/refptr.h>
#include <gdkmm/pixbuf.h>

#include "SystemTray.h"

class SystemTray;

class Notifications
{
	public:
		enum notifyMessages { firstMessageType, torrentFinished=firstMessageType,
			torrentAdded, torrentRemoved, torrentQueued, torrentUnqueued,
			torrentStarted, torrentStopped, lastMessageType};

		void setNotifyMessage(int, bool);
		void showNotifications(bool value) { show_notifications = value; };
		void showNotificationsFromSystray(bool value)
		{
			show_from_systray = value;
		};

		void flushNotification(void);

		Notifications(SystemTray *s);
		~Notifications();

	private:
		Glib::RefPtr<Gdk::Pixbuf> logo_icon;
		bool notify_message[lastMessageType];
		bool show_notifications, show_from_systray, init_period;

		std::queue<std::string> notifications;

		GtkStatusIcon* gtkStatusIcon;

		bool initPeriodFinished();
		bool notifyMessage(std::string&);
		void addNotification(std::string &, int);
};

#endif
