/***************************************************************************
 *            OptionsInfoNoteBookTab.h
 *
 *  Mon Sep 10 00:54:16 2007
 *  Copyright  2007  Fernando Tarín Morales
 *  icemanf@gmail.com
 ****************************************************************************/

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
 
#ifndef _OPTIONSINFONOTEBOOKTAB_H
#define _OPTIONSINFONOTEBOOKTAB_H

#include <gtkmm.h>

#include "Utils.h"

#include "Lince/Torrent.h"

class OptionsInfoNoteBookTab : public Gtk::ScrolledWindow{
	private:
		Glib::ustring nameTab;
	
		Gtk::VBox vbox;
	
		// Header Text
		Gtk::Label headerLabelText;
		Gtk::HBox headerText;
	
		// Max Upload/Download/Connects/Upload slots
		Gtk::Label maxUploadLabel, maxDownloadLabel, maxConnectsLabel, maxUploadSlotsLabel;
		Gtk::SpinButton maxUploadButton, maxDownloadButton, maxConnectsButton, maxUploadSlotsButton;
		Gtk::CheckButton maxUploadCheckButton, maxDownloadCheckButton, maxConnectsCheckButton, maxUploadSlotsCheckButton;
	
		// Share Ratio
		Gtk::HBox shareRatioHBox;
		Gtk::Label shareRatioLabel1, shareRatioLabel2, shareRatioLabel3;
		Gtk::SpinButton shareRatioButton;
		Gtk::CheckButton shareRatioCheckButton;
	
		// Has buttons changed.
		bool maxUploadChanged, maxDownloadChanged, maxConnectsChanged, maxUploadSlotsChanged, shareRatioChanged;
	
		bool areOptionsInitialized;
		
		// Signals
		void setMaxUploadButtonSensitivity();
		void setMaxDownloadButtonSensitivity();
		void setMaxConnectsButtonSensitivity();
		void setMaxUploadSlotsButtonSensitivity();
		void setShareRatioButtonSensitivity();
	
		void setMaxUploadChanged();
		void setMaxDownloadChanged();
		void setMaxConnectsChanged();
		void setMaxUploadsSlotsChanged();
		void setShareRatioChanged();
	
	public:
		OptionsInfoNoteBookTab();
		~OptionsInfoNoteBookTab();
	
		const Glib::ustring & getNameTab() { return nameTab; };
		void updateOptionsInfoNoteBookTab(Lince::Torrent *);
	
		virtual Gtk::Widget * getTabChild(void) { return this; };
};

#endif /* _OPTIONSINFONOTEBOOKTAB_H */

 
