/***************************************************************************
 *            SearchTab.h
 *
 *  Mon Sep 22 16:56:32 2008
 *  Copyright  2008  Fernando Tarín Morales
 *  <icemanf@gmail.com>
 ****************************************************************************/

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
 
#ifndef _SEARCHTAB_H
#define _SEARCHTAB_H

#include <gtkmm/box.h>
#include <gtkmm/entry.h>
#include <gtkmm/notebook.h>

#include <list>

#include "SearchTabResults.h"

#include "Lince/Utils.h"
#include "Utils.h"

#include "BaseTab.h"
#include "GuiSetupManager.h"

class SearchTab: public BaseTab{
	private:
		Gtk::VBox vbox;		
		Gtk::Entry search_data;
		Gtk::Notebook searchs_notebook;

		Gtk::ComboBox categories_search;
		Utils::ModelColumnsIntString m_Columns;
		Glib::RefPtr<Gtk::ListStore> m_refTreeModel;
		
		std::list< SearchTabResults > results_list;
		
		GuiSetupManager * gsm;
				
		void startSearch();
		void stopSearch();
		void removeSearchTab(const Gtk::Widget *);
		
	public:
		SearchTab();
		~SearchTab();
	
		void setGuiSetupManager(GuiSetupManager * _gsm ) { gsm = _gsm; };
		virtual Gtk::Widget * getTabChild(void) { return & vbox; };
};


#endif /* SEARCHTAB_H */
