/***************************************************************************
 *            TorrentInfoTab.h
 *
 *  Fri Aug 31 22:15:08 2007
 *  Copyright  2007  Fernando Tarín Morales
 *  icemanf@gmail.com
 ****************************************************************************/

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
 
#ifndef _TORRENTINFOTAB_H
#define _TORRENTINFOTAB_H

#include "BaseTab.h"
#include "InfoNoteBook.h"
#include "Utils.h"

#include "Lince/Torrent.h"

class NoteBookManager;

class TorrentInfoTab : public BaseTab{
	private:
		libtorrent::sha1_hash torrentHash;
		class NoteBookManager *nb;
		InfoNoteBook infoNoteBook;
		Glib::ustring torrentName, shortName;
		
	public:
		TorrentInfoTab();
		TorrentInfoTab(const Glib::ustring &, const libtorrent::sha1_hash &, NoteBookManager *);
		TorrentInfoTab(const TorrentInfoTab& t);
			
		~TorrentInfoTab();
	
		TorrentInfoTab& operator=(const TorrentInfoTab &);
		bool operator==(const TorrentInfoTab &) const;
		bool operator==(const Glib::ustring &) const;
		bool operator==(const libtorrent::sha1_hash &) const;
	
		void updateTorrentInfoTab(Lince::Torrent *t)
		{
			infoNoteBook.updateInfoNoteBook(t); 
		};
		
		void sendBanMessageToNoteBookManager(Glib::ustring &, int);		
		libtorrent::sha1_hash getTorrentHash(void) { return torrentHash; };
		
		virtual Gtk::Widget * getTabChild(void) { return & infoNoteBook; };
};

#endif /* _TORRENTINFOTAB_H */
